/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;
#endregion

namespace Kabombulator.Components
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class ItemSelector : Microsoft.Xna.Framework.DrawableGameComponent
    {

        protected SpriteBatch sb;
        private Texture2D selection;
        protected internal ContentManager content;
        List<Texture2D> items;
        System.Collections.Specialized.StringCollection names;
        private int selectedIndex;
        Interfaces.IUserInputService input;


        public int SelectedIndex
        {
            get { return selectedIndex; }
            set { selectedIndex = value; }
        }
	        
        public ItemSelector(Game game)
            : base(game)
        {
            // TODO: Construct any child components here            
        }


        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here
            sb = new SpriteBatch(this.GraphicsDevice);
            content = new ContentManager(this.Game.Services);
            items = new List< Texture2D>();
            names = new System.Collections.Specialized.StringCollection();
            input = (Interfaces.IUserInputService)this.Game.Services.GetService(typeof(Interfaces.IUserInputService));
            base.Initialize();
        }

        protected override void LoadGraphicsContent(bool loadAllContent)
        {
            base.LoadGraphicsContent(loadAllContent);
            selection = content.Load<Texture2D>(Content.ItemSelection);
            items.Add( content.Load<Texture2D>(Content.WallPreview));
            names.Add(Content.WallPreview);
        }

        protected override void UnloadGraphicsContent(bool unloadAllContent)
        {
            sb.Dispose();
            sb = null;
            base.UnloadGraphicsContent(unloadAllContent);
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // TODO: Add your update code here

            base.Update(gameTime);
        }

        /// <summary>
        /// Allows the game component to draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Draw(GameTime gameTime)
        {
            // TODO: Add your update code here
            sb.Begin();
            sb.Draw(selection, this.Game.Window.ClientBounds,new Rectangle(10,10,1,1), Color.White); 
            sb.End();

            base.Draw(gameTime);
        }
    }
}


