/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace Kabombulator.Controllers
{
    public class BaseObjectValue : Axiom.Controllers.IControllerValue, IDisposable
    {
        public const int XPosition = 0;
        public const int YPosition = 1;
        public const int ZPosition = 2;
        public const int XScale = 3;
        public const int YScale = 4;
        public const int ZScale = 5;
        public const int Yaw = 6;
        public const int Pitch = 7;
        public const int Roll = 8;        
        private BaseObject obj;
        private int source;


        public BaseObject Object
        {
            get { return obj; }
            set { obj = value; }
        }
       
        public int Source
        {
            get { return source; }
            set { source = value; }
        }
     
        public BaseObjectValue(BaseObject o, int objectValue)
        {
            this.obj = o;
            this.source = objectValue;
        }

        #region IControllerValue Members

        public float Value
        {
            get
            {
                switch (source)
                {
                    case XPosition:
                        return obj != null ? obj.position.X : 0;

                    case YPosition:
                        return obj != null ? obj.position.Y : 0;

                    case ZPosition:
                        return obj != null ? obj.position.Z : 0;

                    case XScale:
                        return obj != null ? obj.scale.X : 0;

                    case YScale:
                        return obj != null ? obj.scale.Y : 0;

                    case ZScale:
                        return obj != null ? obj.scale.Z : 0;

                    case Yaw:
                        return obj != null ? obj.yaw : 0;

                    case Pitch:
                        return obj != null ? obj.pitch : 0;

                    case Roll:
                        return obj != null ? obj.roll : 0;
                                    
                }

                return 0;

            }
            set
            {
                switch (source)
                {
                    case XPosition:
                        if (obj != null) obj.position.X = value;
                        break;

                    case YPosition:
                        if (obj != null) obj.position.Y = value;
                        break;

                    case ZPosition:
                        if (obj != null) obj.position.Z = value;
                        break;

                    case XScale:
                        if (obj != null) obj.scale.X = value;
                        break;

                    case YScale:
                        if (obj != null) obj.scale.Y = value;
                        break;

                    case ZScale:
                        if (obj != null) obj.scale.Z = value;
                        break;

                    case Yaw:
                        if (obj != null) obj.yaw = value;
                        break;

                    case Pitch:
                        if (obj != null) obj.pitch = value;
                        break;

                    case Roll:
                        if (obj != null) obj.roll = value;
                        break;
                }
            }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            this.obj = null;
        }

        #endregion
    }
}
