/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace Kabombulator.Controllers
{
    public class SnapValue : Axiom.Controllers.IControllerValue, IDisposable
    {
       
private Axiom.Controllers.IControllerValue cvalue;
               private float snapValue;

	public float Snap
	{
		get { return snapValue;}
		set { snapValue = value;}
	}
	
	public Axiom.Controllers.IControllerValue ControllerValue
	{
		get { return cvalue;}
		set { cvalue = value;}
	}


        public SnapValue(Axiom.Controllers.IControllerValue cv, float snap)
        {
            this.cvalue = cv;
            this.snapValue = snap;
        }

        #region IControllerValue Members

        public float Value
        {
            get
            {
                if (this.cvalue != null)
                {
                    return (int)(this.cvalue.Value / snapValue) * snapValue;
                }
                else
                {
                    return 0;
                }

            }
            set
            {
                if (this.cvalue != null)  this.cvalue.Value = value;
            }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            this.cvalue = null;
        }

        #endregion
    }
}
