/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Kabombulator
{
    public class DrawableObject : BaseObject,  ICloneable
    {
       protected internal Model model;
        protected internal bool visible = true;
        protected internal float rotation;
        protected internal Color color = Color.White;


        public virtual Color Color
        {
            get { return color; }
            set { color = value; }   
        }


        public virtual InfoBlock[,] GetInfoBlocks(out int xCenter, out int yCenter)
        {
            xCenter = 0;
            yCenter = 0;
            return null;
        }


        public virtual void RotateLeft()
        {
        }

        public virtual void RotateRight()
        {
        }

        public virtual float Rotation
        {
            get { return rotation; }
            //set
            //{
                //rotation = value;
                //if (this.rotation <= 0f) this.rotation = this.rotation + 360f;
                //if (this.rotation >= 360f) this.rotation = 360f - this.rotation;
            //}
        }

        public virtual Model Model
        {
            get { return model; }
            set { model = value; }
        }

        public DrawableObject(KabombulatorGame game)
            : base(game)
        {
        }

        public virtual bool Visible
        {
            get { return this.visible; }
            set { this.visible = value; }
        }

        public virtual void Draw(GameTime gameTime, Camera camera)
        {
            Helpers.DrawModel(gameTime, camera, this.model, this.position, new Vector3(0, this.rotation, 0));
        }

        #region ICloneable Members

        public virtual object Clone()
        {
            DrawableObject item = new DrawableObject(this.Game);
                          
           // item.DrawOrder = this.DrawOrder;
            item.model = this.model;
            item.pitch = this.pitch;
            item.position = this.position;
            item.roll = this.roll;
            item.rotation = this.rotation;
            item.scale = this.scale;
            item.visible = this.visible;
            item.yaw = this.yaw;

            return item;
        }

        #endregion
    }
}
