/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Kabombulator.Effects
{
    public class TexturedEffect: DiffuseEffect
    {

        private Texture2D texture = null;
        private Vector2 offset = Vector2.Zero;


        public float uOffset
        {
            get { return this.offset.X; }
            set
            {
                this.offset.X = value;
                this.Parameters["uOffset"].SetValue(value);
            }
        }

        public float vOffset
        {
            get { return this.offset.Y; }
            set
            {
                this.offset.Y = value;
                this.Parameters["vOffset"].SetValue(value);
            }
        }
        
        public Texture2D Texture
        {
            get { return this.texture; }
            set
            {
                this.texture = value;
                this.Parameters["diffuseTexture"].SetValue(value);
            }
        }

        public override bool EnableAlpha
        {
            get
            {
                return this.alphaEnabled;
            }
            set
            {
                this.alphaEnabled = value;
                if (this.alphaEnabled)
                {
                    this.CurrentTechnique = this.Techniques["TexturedTransparency"];
                }
                else
                {
                    this.CurrentTechnique = this.Techniques["Textured"];

                }
            }
        }
        public TexturedEffect(KabombulatorGame game, Effect cloneSource)
            : base(game, cloneSource)
        {
            this.CurrentTechnique = this.Techniques["Textured"];

            this.texture = this.Parameters["diffuseTexture"].GetValueTexture2D();
            this.offset.X = this.Parameters["uOffset"].GetValueSingle();
            this.offset.Y = this.Parameters["vOffset"].GetValueSingle();
        }
    }
}
