/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
                        using Microsoft.Xna.Framework;
                        using Microsoft.Xna.Framework.Graphics;

namespace Kabombulator.Effects
{
    public class vBombEffect : Effect
    {
        private KabombulatorGame game;
        private float timer = 0;


        public Matrix WorldViewProjection
        {
            get { return this.Parameters["WorldViewProj"].GetValueMatrix(); }
            set { this.Parameters["WorldViewProj"].SetValue(value); }
        }

        public float Timer
        {
            get { return this.timer; }
            set 
            {
                this.timer = value;
                this.Parameters["timer"].SetValue(value); 
            }
        }

        public float Displacement
        {
            get { return this.Parameters["Displacement"].GetValueSingle(); }
            set { this.Parameters["Displacement"].SetValue(value); }
        }

        public float Sharpness
        {
            get { return this.Parameters["Sharpness"].GetValueSingle(); }
            set { this.Parameters["Sharpness"].SetValue(value); }
        }

        public float ColorSharpness
        {
            get { return this.Parameters["ColorSharpness"].GetValueSingle(); }
            set { this.Parameters["ColorSharpness"].SetValue(value); }
        }

        public float Speed
        {
            get { return this.Parameters["Speed"].GetValueSingle(); }
            set { this.Parameters["Speed"].SetValue(value); }
        }

        public float TurbDensity
        {
            get { return this.Parameters["TurbDensity"].GetValueSingle(); }
            set { this.Parameters["TurbDensity"].SetValue(value); }
        }

        public float ColorRange
        {
            get { return this.Parameters["ColorRange"].GetValueSingle(); }
            set { this.Parameters["ColorRange"].SetValue(value); }
        }
        
        public KabombulatorGame Game
        {                                   
            get { return game; }
        } 
           
 
        public Texture2D Texture
        {
            get { return this.Parameters["GradeTex"].GetValueTexture2D(); }
            set { this.Parameters["GradeTex"].SetValue( value); }
        }

        public vBombEffect(KabombulatorGame game, Effect cloneSource)
            :base(game.graphics.GraphicsDevice, cloneSource)
        {
            this.game = game;
            this.CurrentTechnique = this.Techniques["vBomb"];
            this.Displacement = 2f;
            this.Sharpness = 1.9f;
            this.ColorSharpness = 2.9f;
            this.Speed = 0.001f;
            this.TurbDensity = 2.27f;
            this.ColorRange = -2.55f;
            this.timer = this.Timer;

        }
        
    }
}
