/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;


namespace Kabombulator.Services
{
    public class PlayerManager
    {

        private KabombulatorGame game;
        private Collections.PlayerCollection players;


        public void Update(GameTime gameTime)
        {
            foreach (Player p in players)
            {
                p.Update(gameTime);
            }
        }

        public int LocalPlayerCount
        {
            get
            {
                int count = 0;
                foreach (Player p in players)
                {
                    if (p.Type == Player.PlayerType.Local) count++;
                }
                return count;
            }
        }

        public int RemotePlayerCount
        {
            get
            {
                int count = 0;
                foreach (Player p in players)
                {
                    if (p.Type == Player.PlayerType.Remote) count++;
                }
                return count;
            }
        }

        public int ComputerPlayerCount
        {
            get
            {
                int count = 0;
                foreach (Player p in players)
                {
                    if (p.Type == Player.PlayerType.Computer) count++;
                }
                return count;
            }
        }

        public Collections.PlayerCollection Players
        {
            get { return players; }
        }

        public KabombulatorGame Game
        {
            get { return game; }
        }

        public PlayerManager(KabombulatorGame game)
        {
            this.game = game;
            this.players = new Kabombulator.Collections.PlayerCollection();
        }
    }
}
