/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Kabombulator.Properties;

namespace Kabombulator.Structures
{
    public class PowerTower : BaseStructure
    {
        public PowerTower(KabombulatorGame game)
            : base(game)
        {
            this.model = game.models[Content.PowerTower];
            // modify the power tower model to use a vBombEffect
            Effects.vBombEffect fx = new Kabombulator.Effects.vBombEffect(this.Game, this.Game.content.Load<Effect>(Content.vBomb));
            this.model.Meshes[0].MeshParts[3].Effect = fx;
            fx.Texture = this.Game.content.Load<Texture2D>(Content.FireGrade);

            Effects.DiffuseEffect dfx = new Kabombulator.Effects.DiffuseEffect(this.Game, this.Game.content.Load<Effect>(Content.Shaders));
            this.model.Meshes[0].MeshParts[1].Effect = dfx;
            // dfx.DiffuseColor = Color.Red;
            this.cost = 900;
            this.maxHealth = 1000;
            this.health = this.maxHealth;
            this.name = Resources.PowerTower;

        }

        public override void RotateLeft()
        {
            rotation -= 45;
            if (this.rotation <= 0f) this.rotation = this.rotation + 360f;
            if (this.rotation >= 360f) this.rotation = 360f - this.rotation;
        }
        
        public override void RotateRight()
        {
            rotation += 45;
            if (this.rotation <= 0f) this.rotation = this.rotation + 360f;
            if (this.rotation >= 360f) this.rotation = 360f - this.rotation;
        }

        public override InfoBlock[,] GetInfoBlocks(out int xCenter, out int yCenter)
        {
            InfoBlock[,] items = new InfoBlock[3, 3];

            xCenter = 1;
            yCenter = 1;          
            for (int idy = 0; idy <= items.GetUpperBound(0); idy++)
            {
                for (int idx = 0; idx <= items.GetUpperBound(1); idx++)
                {
                    InfoBlock ib = new InfoBlock(this, InfoBlock.InfoType.ReferenceStructure);
                    items[idx, idy] = ib;
                    ib.XPosition = idx - xCenter;
                    ib.YPosition = idy - yCenter;
                }
            }

            items[xCenter, yCenter] = new InfoBlock(this, InfoBlock.InfoType.Structure);
            
            return items;
        }
    }
}
