/*
Created by: X
http://www.createdbyx.com/

Kabombulator is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Kabombulator.Properties;

namespace Kabombulator.Structures
{
    public class Wall : BaseStructure
    {

        public Wall(KabombulatorGame game)
            : base(game)
        {
            this.model = game.models[Content.Wall];
            this.cost = 100;
            this.maxHealth = 100;
            this.health = this.maxHealth;
            this.name = Resources.Wall;
        }

        public override InfoBlock[,] GetInfoBlocks(out int xCenter, out int yCenter)
        {
            InfoBlock[,] items = null;
            xCenter = 0;
            yCenter = 0;

            switch ((int)this.rotation)
            {
                case 0:
                    xCenter = 0;
                    yCenter = 3;
                    items = this.BuildInfoBlocks( 1, 4, xCenter, yCenter);
                    break;

                case 90:
                    xCenter = 3;
                    yCenter = 0;
                    items = this.BuildInfoBlocks( 4, 1, xCenter, yCenter);
                    break;

                case 180:
                    xCenter = 0;
                    yCenter = 0;
                    items = this.BuildInfoBlocks( 1, 4, xCenter, yCenter);
                    break;

                case 270:
                    xCenter = 0;
                    yCenter = 0;
                    items = this.BuildInfoBlocks( 4, 1, xCenter, yCenter);
                    break;
            }

            //if (this.rotation == 45f)
            //{
            //    xCenter = 4;
            //    yCenter = 4;
            //    items = new InfoBlock[6, 6];
            //    for (int idy = 0; idy <= items.GetUpperBound(1); idy++)
            //    {
            //        for (int idx = 0; idx <= items.GetUpperBound(0); idx++)
            //        {
            //            InfoBlock ib = new InfoBlock(this, InfoBlock.InfoType.ReferenceStructure);
            //            items[idx, idy] = ib;
            //            ib.XPosition = idx - xCenter;
            //            ib.YPosition = idy - yCenter;
            //        }
            //    }

            //    // remove upper left corner
            //    items[0, 0] = null;
            //    items[1, 0] = null;
            //    items[0, 1] = null;
            //    items[0, 2] = null;
            //    items[1, 0] = null;
            //    items[1, 1] = null;

            //    // remove upper right corner
            //    items[5, 0] = null;
            //    items[4, 0] = null;
            //    items[5, 1] = null;
            //    items[3, 0] = null;
            //    items[4, 1] = null;
            //    items[5, 2] = null;
            //    items[2, 0] = null;
            //    items[3, 1] = null;
            //    items[4, 2] = null;
            //    items[5, 3] = null;

            //    // remove low right corner
            //    items[0, 5] = null;
            //    items[0, 4] = null;
            //    items[1, 5] = null;
            //    items[0, 3] = null;
            //    items[1, 4] = null;
            //    items[2, 5] = null;
            //    items[0, 2] = null;
            //    items[1, 3] = null;
            //    items[2, 4] = null;
            //    items[3, 5] = null;

            //    // remove low right corner
            //    items[5, 5] = null;

            //    items[xCenter, yCenter] = new InfoBlock(this, InfoBlock.InfoType.Structure);
            //}

            return items;
        }

        public override void RotateLeft()
        {
            rotation -= 90;
            if (this.rotation <= 0f) this.rotation = this.rotation + 360f;
            if (this.rotation >= 360f) this.rotation = 360f - this.rotation;
        }

        public override void RotateRight()
        {
            rotation += 90;
            if (this.rotation <= 0f) this.rotation = this.rotation + 360f;
            if (this.rotation >= 360f) this.rotation = 360f - this.rotation;
        }

        
    }
}
